<template>
<span class="OAuthButton"
    :class='{"OAuthButton--authorized": !!userinfo}'
    @click='clickLogin'>

    <span class="OAuthButton__photo">
        <img v-if='userinfo'
            :src='userinfo?.photo'
            width="100"
            height="100"
            alt=""/>
    </span>

    <span class="OAuthButton__signin" v-if='!userinfo'>Sign in with Google</span>
    <span class="OAuthButton__userinfo" v-else>
        <span v-text='userinfo.name'/>
        <small v-text='userinfo.email'/>
    </span>

    <span class="OAuthButton__logout" v-if='userinfo'
        @click.stop='clickLogout'
        title="Sign out">
        <span class="material-symbols-outlined icon" v-html='"&#XE9BA;"'/>
    </span>

</span>
</template>

<script lang="ts">
import {Vue, Options} from '@/vue';
@Options<GoogleButton>({
    // async mounted() {},
}) export default class GoogleButton extends Vue {
    get userinfo() {
        return this.$store.state.google!.userinfo;
    }

    clickLogin() {
        console.log('IN');
        this.$store.dispatch('google/login');
    }

    clickLogout() {
        console.log('LO');
        this.$store.dispatch('google/logout');
    }
}
</script>

<style lang="less">
@import '@/style/vars';
.OAuthButton {
    cursor: pointer;
    max-width: 240px;
    box-sizing: border-box;
    height: 48px;
    overflow: hidden;
    border-radius: 3px;
    border: 1px solid @google-blue;
    background: @google-blue;
    display: inline-flex;
    flex-flow: row nowrap;
    justify-content: flex-start;
    align-items: center;
    box-shadow: rgba(60, 64, 67, .3) 0 1px 2px 0,
        rgba(60, 64, 67, .15) 0 2px 6px 2px;

    &--authorized {
        color: lightcyan;
        cursor: default;
        pointer-events: none;
    }

    &__photo {
        flex: 0 0 auto;
        box-sizing: border-box;
        background: currentColor;
        height: 100%;
        width: 48px;
        background: white none no-repeat 50% 50%;
        background-image: url('@/img/google-logo.svg');
        & > img {
            width: 100%;
            height: 100%;
            display: block;
        }
    }

    &__signin {
        flex: 0 1 100%;
        padding: 0 1rem;
        text-align: center;
        color: white;
    }

    &__userinfo {
        flex: 0 1 100%;
        min-width: 0;
        padding: .25rem .5rem;
        span,
        small {
            display: block;
            overflow: hidden;
            white-space: nowrap;
            text-overflow: ellipsis;
        }

        span {
            font-size: 87.5%;
            font-weight: 600;
            padding: 2px 0;
        }

        small {
            font-size: 75%;
        }
    }

    &__logout {
        cursor: pointer;
        pointer-events: auto;
        box-sizing: border-box;
        height: 100%;
        margin: 0 0 0 6px;
        padding: 10px 6px 0 10px;
        border-left: 1px solid rgba(255,255,255,.25);
        .icon {
            width: 24px;
            line-height: 26px;
            font-size: 24px;
        }
        &:hover {
            color: white;
            background-color: red;
        }
    }
}
</style>
